<template>
  <i-wrapper top>
    <!-- <nuxt-link to="step-3" class="next">step 4 &gt;</nuxt-link> -->
    <i-stepper :total="auth.onboarding.total" :filled="6" />
    <i-curtain tag="form" @submit="submit()">
      <img src="~assets/images/bubbles-orange.svg" class="bubbles bubbles--custom" />
      <img src="~assets/images/scientist-balloons.png" class="scientist-balloons" />
      <div class="title px-1 text-center">
        {{ $t(`Do you have a partner, {name}?`, { name: auth.onboarding.name }) }}
      </div>
      <div class="normal-text text-center px-1 mb-2">
        {{
          $t(
            `If you're interested, I'll be able to give you an idea how compatible you are and what are your relationship's strengths and weaknesses.`
          )
        }}
      </div>
      <i-round-options
        ref="relationshipOptions"
        v-model="relationshipType"
        :options="relationshipTypeOptions"
        :options-per-line="3" />
      <template #bottom>
        <i-button submit block :loading="isLoading" :disabled="isLoading">{{ $t(`CONTINUE`) }}</i-button>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',

    data() {
      return {
        relationshipType: this.$store.state.auth.onboarding.relationshipType,
        isLoading: false,

        relationshipTypeOptions: [
          {
            key: 'IN_RELATIONSHIP',
            title: this.$t('In a relationship'),
            defaultImage: 'in-relationship.svg',
            selectedImage: 'in-relationship-colored.svg',
          },
          {
            key: 'ENGAGED',
            title: this.$t('Engaged'),
            defaultImage: 'engaged.svg',
            selectedImage: 'engaged-colored.svg',
          },
          {
            key: 'MARRIED',
            title: this.$t('Married'),
            defaultImage: 'married.svg',
            selectedImage: 'married-colored.svg',
          },
          {
            key: 'LOOKING_FOR_PARTNER',
            title: this.$t('Looking for a Partner'),
            defaultImage: 'looking-for-partner.svg',
            selectedImage: 'looking-for-partner-colored.svg',
          },
          {
            key: 'NOT_LOOKING_FOR_RELATIONSHIP',
            title: this.$t('Not looking for a Relationship'),
            defaultImage: 'not-looking-for-relationship.svg',
            selectedImage: 'not-looking-for-relationship-colored.svg',
          },
          {
            key: 'IT_IS_DIFFICULT',
            title: this.$t("It's difficult"),
            defaultImage: 'it-is-difficult.svg',
            selectedImage: 'it-is-difficult-colored.svg',
          },
        ],
      };
    },

    computed: {
      ...mapState(['auth']),
    },

    mounted() {
      //
    },

    methods: {
      async submit() {
        if (this.isLoading) {
          return;
        }

        console.log('SUBMIT');

        if (!this.relationshipType) {
          this.$refs.relationshipOptions.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.relationshipOptions.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post(`onboarding/relationships`, {
            relationshipType: this.relationshipType,
          });

          ga('send', 'event', 'onb_6_relationships');
          this.$store.commit('MERGE_AUTH', { onboarding: response.data.data, user: response.data.data.user });
          await this.$router.push(this.localePath({ name: 'onboarding.interests' }));
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss" scoped>
  .scientist-balloons {
    width: rw(50px);
    margin-top: rs(30px);
  }

  .title {
    font-weight: bold;
    font-size: rf(20px);
    margin-top: rs(15px);
  }

  .normal-text {
    font-size: rf(16px);
    margin-top: rs(8px);
    line-height: 140%;
  }

  .bubbles--custom {
    top: rs(147px);
  }
</style>
